<html>
<head>
<title>OGRE: Ogre::StaticGeometry::GeometryBucket Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li class="current"><a href="classes.html"><span>Classes</span></a></li>
    <li><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="tabs">
  <ul>
    <li><a href="classes.html"><span>Alphabetical&nbsp;List</span></a></li>
    <li><a href="annotated.html"><span>Class&nbsp;List</span></a></li>
    <li><a href="hierarchy.html"><span>Class&nbsp;Hierarchy</span></a></li>
    <li><a href="functions.html"><span>Class&nbsp;Members</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="namespaceOgre.html">Ogre</a>::<a class="el" href="classOgre_1_1StaticGeometry.html">StaticGeometry</a>::<a class="el" href="classOgre_1_1StaticGeometry_1_1GeometryBucket.html">GeometryBucket</a></div>
<h1>Ogre::StaticGeometry::GeometryBucket Class Reference</h1><!-- doxytag: class="Ogre::StaticGeometry::GeometryBucket" --><!-- doxytag: inherits="Ogre::Renderable" -->A <a class="el" href="classOgre_1_1StaticGeometry_1_1GeometryBucket.html" title="A GeometryBucket is a the lowest level bucket where geometry with the same vertex...">GeometryBucket</a> is a the lowest level bucket where geometry with the same vertex &amp; index format is stored.  
<a href="#_details">More...</a>
<p>
<code>#include &lt;<a class="el" href="OgreStaticGeometry_8h-source.html">OgreStaticGeometry.h</a>&gt;</code>
<p>
<div class="dynheader">
Inheritance diagram for Ogre::StaticGeometry::GeometryBucket:</div>
<div class="dynsection">
<center><font size="2">[<a href="graph_legend.html">legend</a>]</font></center></div>

<p>
<a href="classOgre_1_1StaticGeometry_1_1GeometryBucket-members.html">List of all members.</a><table border="0" cellpadding="0" cellspacing="0">
<tr><td></td></tr>
<tr><td colspan="2"><br><h2>Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StaticGeometry_1_1GeometryBucket.html#b7fd4a0ee04901ef5d4fa1dfab3d08f7">GeometryBucket</a> (<a class="el" href="classOgre_1_1StaticGeometry_1_1MaterialBucket.html">MaterialBucket</a> *parent, const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;formatString, const <a class="el" href="classOgre_1_1VertexData.html">VertexData</a> *vData, const <a class="el" href="classOgre_1_1IndexData.html">IndexData</a> *iData)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StaticGeometry_1_1GeometryBucket.html#9b2e1fd7db1b1a60e947d5a62e35ccbf">~GeometryBucket</a> ()</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1StaticGeometry_1_1MaterialBucket.html">MaterialBucket</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StaticGeometry_1_1GeometryBucket.html#08c9ddb2a363d7d90878d69c6776faa7">getParent</a> (void)</td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">const <a class="el" href="classOgre_1_1VertexData.html">VertexData</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StaticGeometry_1_1GeometryBucket.html#c743cdd75e571ab5cdbdb827593fc600">getVertexData</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get the vertex data for this geometry.  <a href="#c743cdd75e571ab5cdbdb827593fc600"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">const <a class="el" href="classOgre_1_1IndexData.html">IndexData</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StaticGeometry_1_1GeometryBucket.html#2adc91a576fd750188ea3a8d558f093f">getIndexData</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get the index data for this geometry.  <a href="#2adc91a576fd750188ea3a8d558f093f"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">const <a class="el" href="classOgre_1_1MaterialPtr.html">MaterialPtr</a> &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StaticGeometry_1_1GeometryBucket.html#c2a7c335895373aea87bfb9df75a780d">getMaterial</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Retrieves a weak reference to the material this renderable object uses. <p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Note that the <a class="el" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a> also has the option to override the getTechnique method to specify a particular <a class="el" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a> to use instead of the best one available. </dd></dl>
  <a href="#c2a7c335895373aea87bfb9df75a780d"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Technique.html">Technique</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StaticGeometry_1_1GeometryBucket.html#cefb31cfffc808d28b6e2e10e821d79a">getTechnique</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Retrieves a pointer to the <a class="el" href="classOgre_1_1Material.html" title="Class encapsulates rendering properties of an object.">Material</a> <a class="el" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a> this renderable object uses.  <a href="#cefb31cfffc808d28b6e2e10e821d79a"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StaticGeometry_1_1GeometryBucket.html#443a670d4074e562338ad668d5c5b0fc">getRenderOperation</a> (<a class="el" href="classOgre_1_1RenderOperation.html">RenderOperation</a> &amp;op)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Gets the render operation required to send this object to the frame buffer.  <a href="#443a670d4074e562338ad668d5c5b0fc"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StaticGeometry_1_1GeometryBucket.html#50414e852eb2a31b74c762ed3e83b281">getWorldTransforms</a> (<a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> *xform) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Gets the world transform matrix / matrices for this renderable object.  <a href="#50414e852eb2a31b74c762ed3e83b281"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a> &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StaticGeometry_1_1GeometryBucket.html#5a513516c112c74e38599dad8a19ba6d">getWorldOrientation</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Gets the worldspace orientation of this renderable; this is used in order to more efficiently update parameters to vertex &amp; fragment programs, since inverting Quaterion and Vector in order to derive object-space positions / directions for cameras and lights is much more efficient than inverting a complete 4x4 matrix, and also eliminates problems introduced by scaling.  <a href="#5a513516c112c74e38599dad8a19ba6d"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a> &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StaticGeometry_1_1GeometryBucket.html#3a10892b72a6ca81e21247d24d54ccf8">getWorldPosition</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Gets the worldspace position of this renderable; this is used in order to more efficiently update parameters to vertex &amp; fragment programs, since inverting Quaterion and Vector in order to derive object-space positions / directions for cameras and lights is much more efficient than inverting a complete 4x4 matrix, and also eliminates problems introduced by scaling.  <a href="#3a10892b72a6ca81e21247d24d54ccf8"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StaticGeometry_1_1GeometryBucket.html#d208d0d9fa6cd294bbdafe7b9cf82e4a">getSquaredViewDepth</a> (const <a class="el" href="classOgre_1_1Camera.html">Camera</a> *cam) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns the camera-relative squared depth of this renderable.  <a href="#d208d0d9fa6cd294bbdafe7b9cf82e4a"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">const <a class="el" href="namespaceOgre.html#b82c6299605910b4051ebb3cc3e5539e">LightList</a> &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StaticGeometry_1_1GeometryBucket.html#7082c43fd02d40dee89b55b947044d64">getLights</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Gets a list of lights, ordered relative to how close they are to this renderable.  <a href="#7082c43fd02d40dee89b55b947044d64"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StaticGeometry_1_1GeometryBucket.html#6c88fc74259edbf600cab80d61c3aae1">getCastsShadows</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Method which reports whether this renderable would normally cast a shadow.  <a href="#6c88fc74259edbf600cab80d61c3aae1"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StaticGeometry_1_1GeometryBucket.html#218ef633a2d0c443f4fd650b30f55fe5">assign</a> (<a class="el" href="structOgre_1_1StaticGeometry_1_1QueuedGeometry.html">QueuedGeometry</a> *qsm)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Try to assign geometry to this bucket.  <a href="#218ef633a2d0c443f4fd650b30f55fe5"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StaticGeometry_1_1GeometryBucket.html#043a89755d05ca8ee6e4334376adae2c">build</a> (bool stencilShadows)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Build.  <a href="#043a89755d05ca8ee6e4334376adae2c"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StaticGeometry_1_1GeometryBucket.html#252fa8cf26efd8519da3556051bba8d8">dump</a> (std::ofstream &amp;of) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Dump contents for diagnostics.  <a href="#252fa8cf26efd8519da3556051bba8d8"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual unsigned short&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Renderable.html#b6ecba3943f56182cddf3b3540afc760">getNumWorldTransforms</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns the number of world transform matrices this renderable requires.  <a href="#b6ecba3943f56182cddf3b3540afc760"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Renderable.html#4136ce4b9d3add5203339327015d872d">setUseIdentityProjection</a> (bool useIdentityProjection)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Sets whether or not to use an 'identity' projection.  <a href="#4136ce4b9d3add5203339327015d872d"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Renderable.html#2a8f061a5f322e0dae2fd6946fc2966f">getUseIdentityProjection</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns whether or not to use an 'identity' projection.  <a href="#2a8f061a5f322e0dae2fd6946fc2966f"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Renderable.html#e53cff42a16304f582ef83ad3017d614">setUseIdentityView</a> (bool useIdentityView)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Sets whether or not to use an 'identity' view.  <a href="#e53cff42a16304f582ef83ad3017d614"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Renderable.html#55df8c0a5347d589ee6ef7beaa38806e">getUseIdentityView</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns whether or not to use an 'identity' view.  <a href="#55df8c0a5347d589ee6ef7beaa38806e"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Renderable.html#9dda967b054609898953bea98ea502b8">getNormaliseNormals</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns whether or not this <a class="el" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a> wishes the hardware to normalise normals.  <a href="#9dda967b054609898953bea98ea502b8"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual const <a class="el" href="namespaceOgre.html#4cfa65f236aec1767fc85022e87059a0">PlaneList</a> &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Renderable.html#1c122c0686168dac942700942bd9f8fc">getClipPlanes</a> () const </td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Renderable.html#572c0331ef2ec650d56063fdc17435f5">setCustomParameter</a> (size_t index, const <a class="el" href="classOgre_1_1Vector4.html">Vector4</a> &amp;value)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Sets a custom parameter for this <a class="el" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>, which may be used to drive calculations for this specific <a class="el" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>, like GPU program parameters.  <a href="#572c0331ef2ec650d56063fdc17435f5"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">const <a class="el" href="classOgre_1_1Vector4.html">Vector4</a> &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Renderable.html#7f5bd1dc9046cb31307ac53914c82fc9">getCustomParameter</a> (size_t index) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Gets the custom value associated with this <a class="el" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a> at the given index.  <a href="#7f5bd1dc9046cb31307ac53914c82fc9"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Renderable.html#42f520f7ba1c57e10130b81ed444affe">_updateCustomGpuParameter</a> (const <a class="el" href="classOgre_1_1GpuProgramParameters_1_1AutoConstantEntry.html">GpuProgramParameters::AutoConstantEntry</a> &amp;constantEntry, <a class="el" href="classOgre_1_1GpuProgramParameters.html">GpuProgramParameters</a> *params) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Update a custom <a class="el" href="classOgre_1_1GpuProgramParameters.html" title="Collects together the program parameters used for a GpuProgram.">GpuProgramParameters</a> constant which is derived from information only this <a class="el" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a> knows.  <a href="#42f520f7ba1c57e10130b81ed444affe"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Renderable.html#2108dfc322953a7bd429be8b62811e56">setPolygonModeOverrideable</a> (bool override)</td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.  <a href="#2108dfc322953a7bd429be8b62811e56"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Renderable.html#723105bef101e2385747f214348984b5">getPolygonModeOverrideable</a> (void) const </td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.  <a href="#723105bef101e2385747f214348984b5"></a><br></td></tr>
<tr><td colspan="2"><br><h2>Protected Types</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">typedef std::map<br>
&lt; size_t, <a class="el" href="classOgre_1_1Vector4.html">Vector4</a> &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Renderable.html#3e944b6d42bc87a19c02f3cc6e677f26">CustomParameterMap</a></td></tr>

<tr><td colspan="2"><br><h2>Protected Member Functions</h2></td></tr>
<tr><td class="memTemplParams" nowrap colspan="2">template&lt;typename T&gt; </td></tr>
<tr><td class="memTemplItemLeft" nowrap align="right" valign="top">void&nbsp;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classOgre_1_1StaticGeometry_1_1GeometryBucket.html#bac912a5e1f232434ef16508c6ed0253">copyIndexes</a> (const T *src, T *dst, size_t count, size_t indexOffset)</td></tr>

<tr><td colspan="2"><br><h2>Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1StaticGeometry.html#0d1eafab98ba3f36b7ac8d39868bd158">QueuedGeometryList</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StaticGeometry_1_1GeometryBucket.html#144fa0aa5fa30964e9aa940585b18437">mQueuedGeometry</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Geometry which has been queued up pre-build (not for deallocation).  <a href="#144fa0aa5fa30964e9aa940585b18437"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1StaticGeometry_1_1MaterialBucket.html">MaterialBucket</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StaticGeometry_1_1GeometryBucket.html#f00853755640ffb1c91b1b19d47c7199">mParent</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Pointer to parent bucket.  <a href="#f00853755640ffb1c91b1b19d47c7199"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StaticGeometry_1_1GeometryBucket.html#7e24b668910d95c23cb3059268b97c19">mFormatString</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">String identifying the vertex / index format.  <a href="#7e24b668910d95c23cb3059268b97c19"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1VertexData.html">VertexData</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StaticGeometry_1_1GeometryBucket.html#0ab5e4a8cfbdfc6371fc5478ad73ca61">mVertexData</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Vertex information, includes current number of vertices committed to be a part of this bucket.  <a href="#0ab5e4a8cfbdfc6371fc5478ad73ca61"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1IndexData.html">IndexData</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StaticGeometry_1_1GeometryBucket.html#910dedbe42c47e7f58d4dba3e0323bb9">mIndexData</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Index information, includes index type which limits the max number of vertices which are allowed in one bucket.  <a href="#910dedbe42c47e7f58d4dba3e0323bb9"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1HardwareIndexBuffer.html#25ba4923e015d46de162f7cc4c256326">HardwareIndexBuffer::IndexType</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StaticGeometry_1_1GeometryBucket.html#5be88f404a20fd8dd1a0a847254c4500">mIndexType</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Size of indexes.  <a href="#5be88f404a20fd8dd1a0a847254c4500"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">size_t&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1StaticGeometry_1_1GeometryBucket.html#f9794e31362b5c99a235ef0a277b475d">mMaxVertexIndex</a></td></tr>

<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Maximum vertex indexable.  <a href="#f9794e31362b5c99a235ef0a277b475d"></a><br></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="el" href="classOgre_1_1Renderable.html#3e944b6d42bc87a19c02f3cc6e677f26">CustomParameterMap</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Renderable.html#7b91506fcf7007e1bf512dade4682731">mCustomParameters</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Renderable.html#4b7b701d41bfd85656829261cbcb3495">mPolygonModeOverrideable</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Renderable.html#27ee15aed77a5bf84b2c3f80c060616e">mUseIdentityProjection</a></td></tr>

<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Renderable.html#536d8ef571a7a177d94e8a6203bd0b35">mUseIdentityView</a></td></tr>

<tr><td colspan="2"><br><h2>Static Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">static const <a class="el" href="namespaceOgre.html#4cfa65f236aec1767fc85022e87059a0">PlaneList</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1Renderable.html#fb8c005cd3df11a051304937ad322112">msDummyPlaneList</a></td></tr>

</table>
<hr><a name="_details"></a><h2>Detailed Description</h2>
A <a class="el" href="classOgre_1_1StaticGeometry_1_1GeometryBucket.html" title="A GeometryBucket is a the lowest level bucket where geometry with the same vertex...">GeometryBucket</a> is a the lowest level bucket where geometry with the same vertex &amp; index format is stored. 
<p>
It also acts as the renderable. 
<p>Definition at line <a class="el" href="OgreStaticGeometry_8h-source.html#l00183">183</a> of file <a class="el" href="OgreStaticGeometry_8h-source.html">OgreStaticGeometry.h</a>.</p>
<hr><h2>Member Typedef Documentation</h2>
<a class="anchor" name="3e944b6d42bc87a19c02f3cc6e677f26"></a><!-- doxytag: member="Ogre::StaticGeometry::GeometryBucket::CustomParameterMap" ref="3e944b6d42bc87a19c02f3cc6e677f26" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef std::map&lt;size_t, <a class="el" href="classOgre_1_1Vector4.html">Vector4</a>&gt; <a class="el" href="classOgre_1_1Renderable.html#3e944b6d42bc87a19c02f3cc6e677f26">Ogre::Renderable::CustomParameterMap</a><code> [protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreRenderable_8h-source.html#l00285">285</a> of file <a class="el" href="OgreRenderable_8h-source.html">OgreRenderable.h</a>.</p>

</div>
</div><p>
<hr><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" name="b7fd4a0ee04901ef5d4fa1dfab3d08f7"></a><!-- doxytag: member="Ogre::StaticGeometry::GeometryBucket::GeometryBucket" ref="b7fd4a0ee04901ef5d4fa1dfab3d08f7" args="(MaterialBucket *parent, const String &amp;formatString, const VertexData *vData, const IndexData *iData)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">Ogre::StaticGeometry::GeometryBucket::GeometryBucket           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1StaticGeometry_1_1MaterialBucket.html">MaterialBucket</a> *&nbsp;</td>
          <td class="paramname"> <em>parent</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>formatString</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1VertexData.html">VertexData</a> *&nbsp;</td>
          <td class="paramname"> <em>vData</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1IndexData.html">IndexData</a> *&nbsp;</td>
          <td class="paramname"> <em>iData</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

</div>
</div><p>
<a class="anchor" name="9b2e1fd7db1b1a60e947d5a62e35ccbf"></a><!-- doxytag: member="Ogre::StaticGeometry::GeometryBucket::~GeometryBucket" ref="9b2e1fd7db1b1a60e947d5a62e35ccbf" args="()" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual Ogre::StaticGeometry::GeometryBucket::~GeometryBucket           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

</div>
</div><p>
<hr><h2>Member Function Documentation</h2>
<a class="anchor" name="bac912a5e1f232434ef16508c6ed0253"></a><!-- doxytag: member="Ogre::StaticGeometry::GeometryBucket::copyIndexes" ref="bac912a5e1f232434ef16508c6ed0253" args="(const T *src, T *dst, size_t count, size_t indexOffset)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::StaticGeometry::GeometryBucket::copyIndexes           </td>
          <td>(</td>
          <td class="paramtype">const T *&nbsp;</td>
          <td class="paramname"> <em>src</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">T *&nbsp;</td>
          <td class="paramname"> <em>dst</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>count</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>indexOffset</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreStaticGeometry_8h-source.html#l00204">204</a> of file <a class="el" href="OgreStaticGeometry_8h-source.html">OgreStaticGeometry.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="08c9ddb2a363d7d90878d69c6776faa7"></a><!-- doxytag: member="Ogre::StaticGeometry::GeometryBucket::getParent" ref="08c9ddb2a363d7d90878d69c6776faa7" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1StaticGeometry_1_1MaterialBucket.html">MaterialBucket</a>* Ogre::StaticGeometry::GeometryBucket::getParent           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreStaticGeometry_8h-source.html#l00222">222</a> of file <a class="el" href="OgreStaticGeometry_8h-source.html">OgreStaticGeometry.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="c743cdd75e571ab5cdbdb827593fc600"></a><!-- doxytag: member="Ogre::StaticGeometry::GeometryBucket::getVertexData" ref="c743cdd75e571ab5cdbdb827593fc600" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="classOgre_1_1VertexData.html">VertexData</a>* Ogre::StaticGeometry::GeometryBucket::getVertexData           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Get the vertex data for this geometry. 
<p>

<p>Definition at line <a class="el" href="OgreStaticGeometry_8h-source.html#l00224">224</a> of file <a class="el" href="OgreStaticGeometry_8h-source.html">OgreStaticGeometry.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="2adc91a576fd750188ea3a8d558f093f"></a><!-- doxytag: member="Ogre::StaticGeometry::GeometryBucket::getIndexData" ref="2adc91a576fd750188ea3a8d558f093f" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="classOgre_1_1IndexData.html">IndexData</a>* Ogre::StaticGeometry::GeometryBucket::getIndexData           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Get the index data for this geometry. 
<p>

<p>Definition at line <a class="el" href="OgreStaticGeometry_8h-source.html#l00226">226</a> of file <a class="el" href="OgreStaticGeometry_8h-source.html">OgreStaticGeometry.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="c2a7c335895373aea87bfb9df75a780d"></a><!-- doxytag: member="Ogre::StaticGeometry::GeometryBucket::getMaterial" ref="c2a7c335895373aea87bfb9df75a780d" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="classOgre_1_1MaterialPtr.html">MaterialPtr</a>&amp; Ogre::StaticGeometry::GeometryBucket::getMaterial           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Retrieves a weak reference to the material this renderable object uses. <p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Note that the <a class="el" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a> also has the option to override the getTechnique method to specify a particular <a class="el" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a> to use instead of the best one available. </dd></dl>
 
<p>

<p>Implements <a class="el" href="classOgre_1_1Renderable.html#7132944645c7b62d6b2bfff6a64fad31">Ogre::Renderable</a>.</p>

</div>
</div><p>
<a class="anchor" name="cefb31cfffc808d28b6e2e10e821d79a"></a><!-- doxytag: member="Ogre::StaticGeometry::GeometryBucket::getTechnique" ref="cefb31cfffc808d28b6e2e10e821d79a" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Technique.html">Technique</a>* Ogre::StaticGeometry::GeometryBucket::getTechnique           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Retrieves a pointer to the <a class="el" href="classOgre_1_1Material.html" title="Class encapsulates rendering properties of an object.">Material</a> <a class="el" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a> this renderable object uses. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>This is to allow Renderables to use a chosen <a class="el" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a> if they wish, otherwise they will use the best <a class="el" href="classOgre_1_1Technique.html" title="Class representing an approach to rendering this particular Material.">Technique</a> available for the <a class="el" href="classOgre_1_1Material.html" title="Class encapsulates rendering properties of an object.">Material</a> they are using. </dd></dl>

<p>Reimplemented from <a class="el" href="classOgre_1_1Renderable.html#afcc80b06f8c74eaac3d35e72ca54842">Ogre::Renderable</a>.</p>

</div>
</div><p>
<a class="anchor" name="443a670d4074e562338ad668d5c5b0fc"></a><!-- doxytag: member="Ogre::StaticGeometry::GeometryBucket::getRenderOperation" ref="443a670d4074e562338ad668d5c5b0fc" args="(RenderOperation &amp;op)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::StaticGeometry::GeometryBucket::getRenderOperation           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1RenderOperation.html">RenderOperation</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>op</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Gets the render operation required to send this object to the frame buffer. 
<p>

<p>Implements <a class="el" href="classOgre_1_1Renderable.html#3621cee2a019e59d3671c1a204caf4c7">Ogre::Renderable</a>.</p>

</div>
</div><p>
<a class="anchor" name="50414e852eb2a31b74c762ed3e83b281"></a><!-- doxytag: member="Ogre::StaticGeometry::GeometryBucket::getWorldTransforms" ref="50414e852eb2a31b74c762ed3e83b281" args="(Matrix4 *xform) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::StaticGeometry::GeometryBucket::getWorldTransforms           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Matrix4.html">Matrix4</a> *&nbsp;</td>
          <td class="paramname"> <em>xform</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Gets the world transform matrix / matrices for this renderable object. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>If the object has any derived transforms, these are expected to be up to date as long as all the <a class="el" href="classOgre_1_1SceneNode.html" title="Class representing a node in the scene graph.">SceneNode</a> structures have been updated before this is called. </dd></dl>
<dl class="user" compact><dt><b></b></dt><dd>This method will populate xform with 1 matrix if it does not use vertex blending. If it does use vertex blending it will fill the passed in pointer with an array of matrices, the length being the value returned from getNumWorldTransforms. </dd></dl>
<dl class="note" compact><dt><b>Note:</b></dt><dd>Internal <a class="el" href="namespaceOgre.html">Ogre</a> never supports non-affine matrix for world transform matrix/matrices, the behavior is undefined if returns non-affine matrix here. </dd></dl>
<dl class="see" compact><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1Matrix4.html#582b20b912ed7d7f8f179505dfbe7a4e" title="Check whether or not the matrix is affine matrix.">Matrix4::isAffine</a>. </dd></dl>

<p>Implements <a class="el" href="classOgre_1_1Renderable.html#897d64f73a5e6ccc45d52a88e86392e1">Ogre::Renderable</a>.</p>

</div>
</div><p>
<a class="anchor" name="5a513516c112c74e38599dad8a19ba6d"></a><!-- doxytag: member="Ogre::StaticGeometry::GeometryBucket::getWorldOrientation" ref="5a513516c112c74e38599dad8a19ba6d" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="classOgre_1_1Quaternion.html">Quaternion</a>&amp; Ogre::StaticGeometry::GeometryBucket::getWorldOrientation           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Gets the worldspace orientation of this renderable; this is used in order to more efficiently update parameters to vertex &amp; fragment programs, since inverting Quaterion and Vector in order to derive object-space positions / directions for cameras and lights is much more efficient than inverting a complete 4x4 matrix, and also eliminates problems introduced by scaling. 
<p>

<p>Implements <a class="el" href="classOgre_1_1Renderable.html#d92d0f87ff9a0d2f8a8ca50610ed209b">Ogre::Renderable</a>.</p>

</div>
</div><p>
<a class="anchor" name="3a10892b72a6ca81e21247d24d54ccf8"></a><!-- doxytag: member="Ogre::StaticGeometry::GeometryBucket::getWorldPosition" ref="3a10892b72a6ca81e21247d24d54ccf8" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="classOgre_1_1Vector3.html">Vector3</a>&amp; Ogre::StaticGeometry::GeometryBucket::getWorldPosition           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Gets the worldspace position of this renderable; this is used in order to more efficiently update parameters to vertex &amp; fragment programs, since inverting Quaterion and Vector in order to derive object-space positions / directions for cameras and lights is much more efficient than inverting a complete 4x4 matrix, and also eliminates problems introduced by scaling. 
<p>

<p>Implements <a class="el" href="classOgre_1_1Renderable.html#a1207c13f1cc2a773cacc9146d935c9b">Ogre::Renderable</a>.</p>

</div>
</div><p>
<a class="anchor" name="d208d0d9fa6cd294bbdafe7b9cf82e4a"></a><!-- doxytag: member="Ogre::StaticGeometry::GeometryBucket::getSquaredViewDepth" ref="d208d0d9fa6cd294bbdafe7b9cf82e4a" args="(const Camera *cam) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> Ogre::StaticGeometry::GeometryBucket::getSquaredViewDepth           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Camera.html">Camera</a> *&nbsp;</td>
          <td class="paramname"> <em>cam</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns the camera-relative squared depth of this renderable. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Used to sort transparent objects. Squared depth is used rather than actual depth to avoid having to perform a square root on the result. </dd></dl>

<p>Implements <a class="el" href="classOgre_1_1Renderable.html#32353addc2f1d02512314b5d1a53c5c1">Ogre::Renderable</a>.</p>

</div>
</div><p>
<a class="anchor" name="7082c43fd02d40dee89b55b947044d64"></a><!-- doxytag: member="Ogre::StaticGeometry::GeometryBucket::getLights" ref="7082c43fd02d40dee89b55b947044d64" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="namespaceOgre.html#b82c6299605910b4051ebb3cc3e5539e">LightList</a>&amp; Ogre::StaticGeometry::GeometryBucket::getLights           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Gets a list of lights, ordered relative to how close they are to this renderable. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Directional lights, which have no position, will always be first on this list. </dd></dl>

<p>Implements <a class="el" href="classOgre_1_1Renderable.html#91a5cc5e517b7c79fa510b9fdcc98691">Ogre::Renderable</a>.</p>

</div>
</div><p>
<a class="anchor" name="6c88fc74259edbf600cab80d61c3aae1"></a><!-- doxytag: member="Ogre::StaticGeometry::GeometryBucket::getCastsShadows" ref="6c88fc74259edbf600cab80d61c3aae1" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Ogre::StaticGeometry::GeometryBucket::getCastsShadows           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Method which reports whether this renderable would normally cast a shadow. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Subclasses should override this if they could have been used to generate a shadow. </dd></dl>

<p>Reimplemented from <a class="el" href="classOgre_1_1Renderable.html#1ce8341c18f75ef0b6d818eceea5b2e2">Ogre::Renderable</a>.</p>

</div>
</div><p>
<a class="anchor" name="218ef633a2d0c443f4fd650b30f55fe5"></a><!-- doxytag: member="Ogre::StaticGeometry::GeometryBucket::assign" ref="218ef633a2d0c443f4fd650b30f55fe5" args="(QueuedGeometry *qsm)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Ogre::StaticGeometry::GeometryBucket::assign           </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structOgre_1_1StaticGeometry_1_1QueuedGeometry.html">QueuedGeometry</a> *&nbsp;</td>
          <td class="paramname"> <em>qsm</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Try to assign geometry to this bucket. 
<p>
<dl class="return" compact><dt><b>Returns:</b></dt><dd>false if there is no room left in this bucket </dd></dl>

</div>
</div><p>
<a class="anchor" name="043a89755d05ca8ee6e4334376adae2c"></a><!-- doxytag: member="Ogre::StaticGeometry::GeometryBucket::build" ref="043a89755d05ca8ee6e4334376adae2c" args="(bool stencilShadows)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::StaticGeometry::GeometryBucket::build           </td>
          <td>(</td>
          <td class="paramtype">bool&nbsp;</td>
          <td class="paramname"> <em>stencilShadows</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Build. 
<p>

</div>
</div><p>
<a class="anchor" name="252fa8cf26efd8519da3556051bba8d8"></a><!-- doxytag: member="Ogre::StaticGeometry::GeometryBucket::dump" ref="252fa8cf26efd8519da3556051bba8d8" args="(std::ofstream &amp;of) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::StaticGeometry::GeometryBucket::dump           </td>
          <td>(</td>
          <td class="paramtype">std::ofstream &amp;&nbsp;</td>
          <td class="paramname"> <em>of</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Dump contents for diagnostics. 
<p>

</div>
</div><p>
<a class="anchor" name="b6ecba3943f56182cddf3b3540afc760"></a><!-- doxytag: member="Ogre::StaticGeometry::GeometryBucket::getNumWorldTransforms" ref="b6ecba3943f56182cddf3b3540afc760" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual unsigned short Ogre::Renderable::getNumWorldTransforms           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns the number of world transform matrices this renderable requires. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>When a renderable uses vertex blending, it uses multiple world matrices instead of a single one. Each vertex sent to the pipeline can reference one or more matrices in this list with given weights. If a renderable does not use vertex blending this method returns 1, which is the default for simplicity. </dd></dl>

<p>Reimplemented in <a class="el" href="classOgre_1_1BorderRenderable.html#b1b34c4ec0b24e6cc3ff71f9979639c8">Ogre::BorderRenderable</a>, <a class="el" href="classOgre_1_1InstancedGeometry_1_1GeometryBucket.html#75e60811f40b80d8b5063c5726f17a8e">Ogre::InstancedGeometry::GeometryBucket</a>, and <a class="el" href="classOgre_1_1SubEntity.html#487d0eb60081f28c8a347ac8d036a133">Ogre::SubEntity</a>.</p>

<p>Definition at line <a class="el" href="OgreRenderable_8h-source.html#l00111">111</a> of file <a class="el" href="OgreRenderable_8h-source.html">OgreRenderable.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="4136ce4b9d3add5203339327015d872d"></a><!-- doxytag: member="Ogre::StaticGeometry::GeometryBucket::setUseIdentityProjection" ref="4136ce4b9d3add5203339327015d872d" args="(bool useIdentityProjection)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::Renderable::setUseIdentityProjection           </td>
          <td>(</td>
          <td class="paramtype">bool&nbsp;</td>
          <td class="paramname"> <em>useIdentityProjection</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Sets whether or not to use an 'identity' projection. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Usually <a class="el" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a> objects will use a projection matrix as determined by the active camera. However, if they want they can cancel this out and use an identity projection, which effectively projects in 2D using a {-1, 1} view space. Useful for overlay rendering. Normal renderables need not change this. The default is false. </dd></dl>
<dl class="see" compact><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1Renderable.html#2a8f061a5f322e0dae2fd6946fc2966f" title="Returns whether or not to use an &#39;identity&#39; projection.">Renderable::getUseIdentityProjection</a> </dd></dl>

<p>Definition at line <a class="el" href="OgreRenderable_8h-source.html#l00122">122</a> of file <a class="el" href="OgreRenderable_8h-source.html">OgreRenderable.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="2a8f061a5f322e0dae2fd6946fc2966f"></a><!-- doxytag: member="Ogre::StaticGeometry::GeometryBucket::getUseIdentityProjection" ref="2a8f061a5f322e0dae2fd6946fc2966f" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Ogre::Renderable::getUseIdentityProjection           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns whether or not to use an 'identity' projection. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Usually <a class="el" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a> objects will use a projection matrix as determined by the active camera. However, if they want they can cancel this out and use an identity projection, which effectively projects in 2D using a {-1, 1} view space. Useful for overlay rendering. Normal renderables need not change this. </dd></dl>
<dl class="see" compact><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1Renderable.html#4136ce4b9d3add5203339327015d872d" title="Sets whether or not to use an &#39;identity&#39; projection.">Renderable::setUseIdentityProjection</a> </dd></dl>

<p>Definition at line <a class="el" href="OgreRenderable_8h-source.html#l00136">136</a> of file <a class="el" href="OgreRenderable_8h-source.html">OgreRenderable.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="e53cff42a16304f582ef83ad3017d614"></a><!-- doxytag: member="Ogre::StaticGeometry::GeometryBucket::setUseIdentityView" ref="e53cff42a16304f582ef83ad3017d614" args="(bool useIdentityView)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::Renderable::setUseIdentityView           </td>
          <td>(</td>
          <td class="paramtype">bool&nbsp;</td>
          <td class="paramname"> <em>useIdentityView</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Sets whether or not to use an 'identity' view. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Usually <a class="el" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a> objects will use a view matrix as determined by the active camera. However, if they want they can cancel this out and use an identity matrix, which means all geometry is assumed to be relative to camera space already. Useful for overlay rendering. Normal renderables need not change this. The default is false. </dd></dl>
<dl class="see" compact><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1Renderable.html#55df8c0a5347d589ee6ef7beaa38806e" title="Returns whether or not to use an &#39;identity&#39; view.">Renderable::getUseIdentityView</a> </dd></dl>

<p>Definition at line <a class="el" href="OgreRenderable_8h-source.html#l00147">147</a> of file <a class="el" href="OgreRenderable_8h-source.html">OgreRenderable.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="55df8c0a5347d589ee6ef7beaa38806e"></a><!-- doxytag: member="Ogre::StaticGeometry::GeometryBucket::getUseIdentityView" ref="55df8c0a5347d589ee6ef7beaa38806e" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool Ogre::Renderable::getUseIdentityView           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns whether or not to use an 'identity' view. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Usually <a class="el" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a> objects will use a view matrix as determined by the active camera. However, if they want they can cancel this out and use an identity matrix, which means all geometry is assumed to be relative to camera space already. Useful for overlay rendering. Normal renderables need not change this. </dd></dl>
<dl class="see" compact><dt><b>See also:</b></dt><dd><a class="el" href="classOgre_1_1Renderable.html#e53cff42a16304f582ef83ad3017d614" title="Sets whether or not to use an &#39;identity&#39; view.">Renderable::setUseIdentityView</a> </dd></dl>

<p>Definition at line <a class="el" href="OgreRenderable_8h-source.html#l00161">161</a> of file <a class="el" href="OgreRenderable_8h-source.html">OgreRenderable.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="9dda967b054609898953bea98ea502b8"></a><!-- doxytag: member="Ogre::StaticGeometry::GeometryBucket::getNormaliseNormals" ref="9dda967b054609898953bea98ea502b8" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool Ogre::Renderable::getNormaliseNormals           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Returns whether or not this <a class="el" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a> wishes the hardware to normalise normals. 
<p>

<p>Reimplemented in <a class="el" href="classOgre_1_1SubEntity.html#66eec09c10be4c6b3d82f49bdcfc99f0">Ogre::SubEntity</a>.</p>

<p>Definition at line <a class="el" href="OgreRenderable_8h-source.html#l00171">171</a> of file <a class="el" href="OgreRenderable_8h-source.html">OgreRenderable.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="1c122c0686168dac942700942bd9f8fc"></a><!-- doxytag: member="Ogre::StaticGeometry::GeometryBucket::getClipPlanes" ref="1c122c0686168dac942700942bd9f8fc" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const <a class="el" href="namespaceOgre.html#4cfa65f236aec1767fc85022e87059a0">PlaneList</a>&amp; Ogre::Renderable::getClipPlanes           </td>
          <td>(</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreRenderable_8h-source.html#l00179">179</a> of file <a class="el" href="OgreRenderable_8h-source.html">OgreRenderable.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="572c0331ef2ec650d56063fdc17435f5"></a><!-- doxytag: member="Ogre::StaticGeometry::GeometryBucket::setCustomParameter" ref="572c0331ef2ec650d56063fdc17435f5" args="(size_t index, const Vector4 &amp;value)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void Ogre::Renderable::setCustomParameter           </td>
          <td>(</td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>index</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1Vector4.html">Vector4</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>value</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Sets a custom parameter for this <a class="el" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>, which may be used to drive calculations for this specific <a class="el" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>, like GPU program parameters. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>Calling this method simply associates a numeric index with a 4-dimensional value for this specific <a class="el" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>. This is most useful if the material which this <a class="el" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a> uses a vertex or fragment program, and has an ACT_CUSTOM parameter entry. This parameter entry can refer to the index you specify as part of this call, thereby mapping a custom parameter for this renderable to a program parameter. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>index</em>&nbsp;</td><td>The index with which to associate the value. Note that this does not have to start at 0, and can include gaps. It also has no direct correlation with a GPU program parameter index - the mapping between the two is performed by the ACT_CUSTOM entry, if that is used. </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>value</em>&nbsp;</td><td>The value to associate. </td></tr>
  </table>
</dl>

<p>Definition at line <a class="el" href="OgreRenderable_8h-source.html#l00204">204</a> of file <a class="el" href="OgreRenderable_8h-source.html">OgreRenderable.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="7f5bd1dc9046cb31307ac53914c82fc9"></a><!-- doxytag: member="Ogre::StaticGeometry::GeometryBucket::getCustomParameter" ref="7f5bd1dc9046cb31307ac53914c82fc9" args="(size_t index) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="classOgre_1_1Vector4.html">Vector4</a>&amp; Ogre::Renderable::getCustomParameter           </td>
          <td>(</td>
          <td class="paramtype">size_t&nbsp;</td>
          <td class="paramname"> <em>index</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Gets the custom value associated with this <a class="el" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a> at the given index. 
<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>@see</em>&nbsp;</td><td>setCustomParaemter for full details. </td></tr>
  </table>
</dl>

<p>Definition at line <a class="el" href="OgreRenderable_8h-source.html#l00213">213</a> of file <a class="el" href="OgreRenderable_8h-source.html">OgreRenderable.h</a>.</p>

<p>References <a class="el" href="OgreException_8h-source.html#l00108">Ogre::Exception::ERR_ITEM_NOT_FOUND</a>, and <a class="el" href="OgreException_8h-source.html#l00336">OGRE_EXCEPT</a>.</p>

</div>
</div><p>
<a class="anchor" name="42f520f7ba1c57e10130b81ed444affe"></a><!-- doxytag: member="Ogre::StaticGeometry::GeometryBucket::_updateCustomGpuParameter" ref="42f520f7ba1c57e10130b81ed444affe" args="(const GpuProgramParameters::AutoConstantEntry &amp;constantEntry, GpuProgramParameters *params) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::Renderable::_updateCustomGpuParameter           </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1GpuProgramParameters_1_1AutoConstantEntry.html">GpuProgramParameters::AutoConstantEntry</a> &amp;&nbsp;</td>
          <td class="paramname"> <em>constantEntry</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1GpuProgramParameters.html">GpuProgramParameters</a> *&nbsp;</td>
          <td class="paramname"> <em>params</em></td><td>&nbsp;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td><td width="100%"> const<code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Update a custom <a class="el" href="classOgre_1_1GpuProgramParameters.html" title="Collects together the program parameters used for a GpuProgram.">GpuProgramParameters</a> constant which is derived from information only this <a class="el" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a> knows. 
<p>
<dl class="remark" compact><dt><b>Remarks:</b></dt><dd>This method allows a <a class="el" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a> to map in a custom GPU program parameter based on it's own data. This is represented by a GPU auto parameter of ACT_CUSTOM, and to allow there to be more than one of these per <a class="el" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a>, the 'data' field on the auto parameter will identify which parameter is being updated. The implementation of this method must identify the parameter being updated, and call a 'setConstant' method on the passed in <a class="el" href="classOgre_1_1GpuProgramParameters.html" title="Collects together the program parameters used for a GpuProgram.">GpuProgramParameters</a> object, using the details provided in the incoming auto constant setting to identify the index at which to set the parameter. </dd></dl>
<dl class="user" compact><dt><b></b></dt><dd>You do not need to override this method if you're using the standard sets of data associated with the <a class="el" href="classOgre_1_1Renderable.html" title="Abstract class defining the interface all renderable objects must implement.">Renderable</a> as provided by setCustomParameter and getCustomParameter. By default, the implementation will map from the value indexed by the 'constantEntry.data' parameter to a value previously set by setCustomParameter. But custom Renderables are free to override this if they want, in any case. </dd></dl>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>constantEntry</em>&nbsp;</td><td>The auto constant entry referring to the parameter being updated </td></tr>
    <tr><td valign="top"></td><td valign="top"><em>params</em>&nbsp;</td><td>The parameters object which this method should call to set the updated parameters. </td></tr>
  </table>
</dl>

<p>Reimplemented in <a class="el" href="classOgre_1_1SubEntity.html#271214f0a12235cbd2ced91f9f2d28d3">Ogre::SubEntity</a>.</p>

<p>Definition at line <a class="el" href="OgreRenderable_8h-source.html#l00252">252</a> of file <a class="el" href="OgreRenderable_8h-source.html">OgreRenderable.h</a>.</p>

<p>References <a class="el" href="classOgre_1_1GpuProgramParameters.html#f9e29d2087c860156de6792405b679d4">Ogre::GpuProgramParameters::_writeRawConstant()</a>, <a class="el" href="OgreGpuProgram_8h-source.html#l00668">Ogre::GpuProgramParameters::AutoConstantEntry::data</a>, <a class="el" href="OgreGpuProgram_8h-source.html#l00665">Ogre::GpuProgramParameters::AutoConstantEntry::elementCount</a>, and <a class="el" href="OgreGpuProgram_8h-source.html#l00661">Ogre::GpuProgramParameters::AutoConstantEntry::physicalIndex</a>.</p>

</div>
</div><p>
<a class="anchor" name="2108dfc322953a7bd429be8b62811e56"></a><!-- doxytag: member="Ogre::StaticGeometry::GeometryBucket::setPolygonModeOverrideable" ref="2108dfc322953a7bd429be8b62811e56" args="(bool override)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void Ogre::Renderable::setPolygonModeOverrideable           </td>
          <td>(</td>
          <td class="paramtype">bool&nbsp;</td>
          <td class="paramname"> <em>override</em>          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting. 
<p>
<dl compact><dt><b>Parameters:</b></dt><dd>
  <table border="0" cellspacing="2" cellpadding="0">
    <tr><td valign="top"></td><td valign="top"><em>override</em>&nbsp;</td><td>true means that a lower camera detail will override this renderables detail level, false means it won't. </td></tr>
  </table>
</dl>

<p>Definition at line <a class="el" href="OgreRenderable_8h-source.html#l00269">269</a> of file <a class="el" href="OgreRenderable_8h-source.html">OgreRenderable.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="723105bef101e2385747f214348984b5"></a><!-- doxytag: member="Ogre::StaticGeometry::GeometryBucket::getPolygonModeOverrideable" ref="723105bef101e2385747f214348984b5" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool Ogre::Renderable::getPolygonModeOverrideable           </td>
          <td>(</td>
          <td class="paramtype">void&nbsp;</td>
          <td class="paramname">          </td>
          <td>&nbsp;)&nbsp;</td>
          <td width="100%"> const<code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting. 
<p>

<p>Reimplemented in <a class="el" href="classOgre_1_1BorderRenderable.html#0019a2f8bd469ca970f13ff6f0c24ee7">Ogre::BorderRenderable</a>.</p>

<p>Definition at line <a class="el" href="OgreRenderable_8h-source.html#l00277">277</a> of file <a class="el" href="OgreRenderable_8h-source.html">OgreRenderable.h</a>.</p>

</div>
</div><p>
<hr><h2>Member Data Documentation</h2>
<a class="anchor" name="144fa0aa5fa30964e9aa940585b18437"></a><!-- doxytag: member="Ogre::StaticGeometry::GeometryBucket::mQueuedGeometry" ref="144fa0aa5fa30964e9aa940585b18437" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1StaticGeometry.html#0d1eafab98ba3f36b7ac8d39868bd158">QueuedGeometryList</a> <a class="el" href="classOgre_1_1StaticGeometry_1_1GeometryBucket.html#144fa0aa5fa30964e9aa940585b18437">Ogre::StaticGeometry::GeometryBucket::mQueuedGeometry</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Geometry which has been queued up pre-build (not for deallocation). 
<p>

<p>Definition at line <a class="el" href="OgreStaticGeometry_8h-source.html#l00187">187</a> of file <a class="el" href="OgreStaticGeometry_8h-source.html">OgreStaticGeometry.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="f00853755640ffb1c91b1b19d47c7199"></a><!-- doxytag: member="Ogre::StaticGeometry::GeometryBucket::mParent" ref="f00853755640ffb1c91b1b19d47c7199" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1StaticGeometry_1_1MaterialBucket.html">MaterialBucket</a>* <a class="el" href="classOgre_1_1StaticGeometry_1_1GeometryBucket.html#f00853755640ffb1c91b1b19d47c7199">Ogre::StaticGeometry::GeometryBucket::mParent</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Pointer to parent bucket. 
<p>

<p>Definition at line <a class="el" href="OgreStaticGeometry_8h-source.html#l00189">189</a> of file <a class="el" href="OgreStaticGeometry_8h-source.html">OgreStaticGeometry.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="7e24b668910d95c23cb3059268b97c19"></a><!-- doxytag: member="Ogre::StaticGeometry::GeometryBucket::mFormatString" ref="7e24b668910d95c23cb3059268b97c19" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> <a class="el" href="classOgre_1_1StaticGeometry_1_1GeometryBucket.html#7e24b668910d95c23cb3059268b97c19">Ogre::StaticGeometry::GeometryBucket::mFormatString</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
String identifying the vertex / index format. 
<p>

<p>Definition at line <a class="el" href="OgreStaticGeometry_8h-source.html#l00191">191</a> of file <a class="el" href="OgreStaticGeometry_8h-source.html">OgreStaticGeometry.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="0ab5e4a8cfbdfc6371fc5478ad73ca61"></a><!-- doxytag: member="Ogre::StaticGeometry::GeometryBucket::mVertexData" ref="0ab5e4a8cfbdfc6371fc5478ad73ca61" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1VertexData.html">VertexData</a>* <a class="el" href="classOgre_1_1StaticGeometry_1_1GeometryBucket.html#0ab5e4a8cfbdfc6371fc5478ad73ca61">Ogre::StaticGeometry::GeometryBucket::mVertexData</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Vertex information, includes current number of vertices committed to be a part of this bucket. 
<p>

<p>Definition at line <a class="el" href="OgreStaticGeometry_8h-source.html#l00194">194</a> of file <a class="el" href="OgreStaticGeometry_8h-source.html">OgreStaticGeometry.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="910dedbe42c47e7f58d4dba3e0323bb9"></a><!-- doxytag: member="Ogre::StaticGeometry::GeometryBucket::mIndexData" ref="910dedbe42c47e7f58d4dba3e0323bb9" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1IndexData.html">IndexData</a>* <a class="el" href="classOgre_1_1StaticGeometry_1_1GeometryBucket.html#910dedbe42c47e7f58d4dba3e0323bb9">Ogre::StaticGeometry::GeometryBucket::mIndexData</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Index information, includes index type which limits the max number of vertices which are allowed in one bucket. 
<p>

<p>Definition at line <a class="el" href="OgreStaticGeometry_8h-source.html#l00197">197</a> of file <a class="el" href="OgreStaticGeometry_8h-source.html">OgreStaticGeometry.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="5be88f404a20fd8dd1a0a847254c4500"></a><!-- doxytag: member="Ogre::StaticGeometry::GeometryBucket::mIndexType" ref="5be88f404a20fd8dd1a0a847254c4500" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1HardwareIndexBuffer.html#25ba4923e015d46de162f7cc4c256326">HardwareIndexBuffer::IndexType</a> <a class="el" href="classOgre_1_1StaticGeometry_1_1GeometryBucket.html#5be88f404a20fd8dd1a0a847254c4500">Ogre::StaticGeometry::GeometryBucket::mIndexType</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Size of indexes. 
<p>

<p>Definition at line <a class="el" href="OgreStaticGeometry_8h-source.html#l00199">199</a> of file <a class="el" href="OgreStaticGeometry_8h-source.html">OgreStaticGeometry.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="f9794e31362b5c99a235ef0a277b475d"></a><!-- doxytag: member="Ogre::StaticGeometry::GeometryBucket::mMaxVertexIndex" ref="f9794e31362b5c99a235ef0a277b475d" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">size_t <a class="el" href="classOgre_1_1StaticGeometry_1_1GeometryBucket.html#f9794e31362b5c99a235ef0a277b475d">Ogre::StaticGeometry::GeometryBucket::mMaxVertexIndex</a><code> [protected]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>
Maximum vertex indexable. 
<p>

<p>Definition at line <a class="el" href="OgreStaticGeometry_8h-source.html#l00201">201</a> of file <a class="el" href="OgreStaticGeometry_8h-source.html">OgreStaticGeometry.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="fb8c005cd3df11a051304937ad322112"></a><!-- doxytag: member="Ogre::StaticGeometry::GeometryBucket::msDummyPlaneList" ref="fb8c005cd3df11a051304937ad322112" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const <a class="el" href="namespaceOgre.html#4cfa65f236aec1767fc85022e87059a0">PlaneList</a> <a class="el" href="classOgre_1_1Renderable.html#fb8c005cd3df11a051304937ad322112">Ogre::Renderable::msDummyPlaneList</a><code> [static, protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreRenderable_8h-source.html#l00284">284</a> of file <a class="el" href="OgreRenderable_8h-source.html">OgreRenderable.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="7b91506fcf7007e1bf512dade4682731"></a><!-- doxytag: member="Ogre::StaticGeometry::GeometryBucket::mCustomParameters" ref="7b91506fcf7007e1bf512dade4682731" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Renderable.html#3e944b6d42bc87a19c02f3cc6e677f26">CustomParameterMap</a> <a class="el" href="classOgre_1_1Renderable.html#7b91506fcf7007e1bf512dade4682731">Ogre::Renderable::mCustomParameters</a><code> [protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreRenderable_8h-source.html#l00286">286</a> of file <a class="el" href="OgreRenderable_8h-source.html">OgreRenderable.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="4b7b701d41bfd85656829261cbcb3495"></a><!-- doxytag: member="Ogre::StaticGeometry::GeometryBucket::mPolygonModeOverrideable" ref="4b7b701d41bfd85656829261cbcb3495" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1Renderable.html#4b7b701d41bfd85656829261cbcb3495">Ogre::Renderable::mPolygonModeOverrideable</a><code> [protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreRenderable_8h-source.html#l00287">287</a> of file <a class="el" href="OgreRenderable_8h-source.html">OgreRenderable.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="27ee15aed77a5bf84b2c3f80c060616e"></a><!-- doxytag: member="Ogre::StaticGeometry::GeometryBucket::mUseIdentityProjection" ref="27ee15aed77a5bf84b2c3f80c060616e" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1Renderable.html#27ee15aed77a5bf84b2c3f80c060616e">Ogre::Renderable::mUseIdentityProjection</a><code> [protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreRenderable_8h-source.html#l00288">288</a> of file <a class="el" href="OgreRenderable_8h-source.html">OgreRenderable.h</a>.</p>

</div>
</div><p>
<a class="anchor" name="536d8ef571a7a177d94e8a6203bd0b35"></a><!-- doxytag: member="Ogre::StaticGeometry::GeometryBucket::mUseIdentityView" ref="536d8ef571a7a177d94e8a6203bd0b35" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1Renderable.html#536d8ef571a7a177d94e8a6203bd0b35">Ogre::Renderable::mUseIdentityView</a><code> [protected, inherited]</code>          </td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>

<p>Definition at line <a class="el" href="OgreRenderable_8h-source.html#l00289">289</a> of file <a class="el" href="OgreRenderable_8h-source.html">OgreRenderable.h</a>.</p>

</div>
</div><p>
<hr>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreStaticGeometry_8h-source.html">OgreStaticGeometry.h</a></ul>
<hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:54:06 2008
</p>
</body>
</html>
